<?xml version="1.0"?>
<!--
	The lestes compiler suite
	Copyright (C) 2002, 2003, 2004, 2005 Miroslav Tichy
	Copyright (C) 2002, 2003, 2004, 2005 Petr Zika
	Copyright (C) 2002, 2003, 2004, 2005 Vojtech Hala
	Copyright (C) 2002, 2003, 2004, 2005 Jiri Kosina
	Copyright (C) 2002, 2003, 2004, 2005 Pavel Sanda
	Copyright (C) 2002, 2003, 2004, 2005 Jan Zouhar
	Copyright (C) 2002, 2003, 2004, 2005 Rudolf Thomas

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; version 2 of the License.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	See the full text of the GNU General Public License version 2, and
	the limitations in the file doc/LICENSE.

	By accepting the license the licensee waives any and all claims
	against the copyright holder(s) related in whole or in part to the
	work, its use, and/or the inability to use it.
-->
<!DOCTYPE xsl:transform [
    <!ENTITY nl "&#x0A;">
    <!ENTITY tab "&#x09;">
]>
<xsl:transform version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:lsd="http://lestes.jikos.cz/schemas/lsd">
	<!-- Generate C++ headers for data structures from XML description. -->
	<xsl:output method="text" encoding="ISO-8859-1"/>

	<xsl:include href="common.xslt"/>

	<xsl:template match="lsd:lsd">
		<xsl:text>// This file is automatically generated, do not edit.&nl;</xsl:text>

		<xsl:for-each select="lsd:dox[ @file!='cc']">	<!-- doxygen info about output file -->
			<xsl:text>&nl;/*!&nl;&tab;\file&nl;</xsl:text>
			<xsl:if test="string-length(lsd:bri)">
				<xsl:value-of select="concat('&tab;\brief ',lsd:bri,'&nl;')"/>
			</xsl:if>
			<xsl:if test="string-length(lsd:det)">
				<xsl:text>&tab;</xsl:text>
				<xsl:apply-templates mode="html-text" select="lsd:det/node()"/>
				<xsl:text>&nl;</xsl:text>
			</xsl:if>
			<xsl:text>*/&nl;</xsl:text>
		</xsl:for-each>
		<xsl:text>&nl;</xsl:text>


		<xsl:call-template name="open-header"/>	<!-- classical preprocesor hack to avoid inclusion problems -->

		<xsl:call-template name="imports"/>		<!-- #include ... -->
		<xsl:text>#include &lt;lestes/std/objectize_macros.hh&gt;&nl;</xsl:text>

		<xsl:for-each select="lsd:foreign-class">
			<xsl:for-each select="lsd:p">
				<xsl:value-of select="concat('package(', ./text(), ');&nl;')" />
			</xsl:for-each>
			<xsl:value-of select="concat('class ',@name,';&nl;')"/>

			<xsl:for-each select="lsd:p">
				<xsl:sort order="descending" data-type="number" select="position()" />
				<xsl:value-of select="concat('end_package(', ./text(), ');&nl;')" />
			</xsl:for-each>
			<xsl:text>&nl;</xsl:text>
		</xsl:for-each>

		<xsl:call-template name="open-packages"/>	<!-- package(...); -->

		<xsl:if test="lsd:hh-header/text() != ''">
			<xsl:value-of select="concat('&nl;',lsd:hh-header,'&nl;&nl;&nl;')"/>		<!-- output file prolog -->
		</xsl:if>

		<xsl:call-template name="enums"/>

		<xsl:text>&nl;</xsl:text>			<!-- forward declaration for each class -->
		<xsl:for-each select="lsd:forward-class | lsd:class | lsd:class/lsd:visitor">
			<xsl:value-of select="concat('class ',@name,';&nl;')"/>
		</xsl:for-each>
		<xsl:text>&nl;&nl;</xsl:text>

		<xsl:call-template name="typedefs"/>

		<xsl:for-each select="lsd:class">		<!-- list of class declarations -->
			<xsl:call-template name="doxygen"/>
			<xsl:value-of select="concat('class ',@name)"/>
			<xsl:text> : public </xsl:text>
			<xsl:call-template name="resolve-base"/>
			<xsl:text> {&nl;</xsl:text>
			<xsl:call-template name="class-body">
				<xsl:with-param name="this-class-name" select="@name"/>
				<xsl:with-param name="base-class-name" select="@name"/>
				<xsl:with-param name="abstract" select="@abstract"/>
			</xsl:call-template>
			<xsl:value-of select="concat('&nl;}; // ',@name,'&nl;&nl;&nl;')"/>
		</xsl:for-each>


		<xsl:if test="lsd:hh-footer/text() != ''">
			<xsl:value-of select="concat('&nl;',lsd:hh-footer,'&nl;')"/>		<!-- output file epilog -->
		</xsl:if>

		<xsl:call-template name="close-packages"/>	<!-- end_package(...); -->

		<xsl:if test="/lsd:lsd/lsd:enum | /lsd:lsd/lsd:class/lsd:enum">
			<xsl:text>package(lestes);&nl;</xsl:text>
			<xsl:text>package(std);&nl;</xsl:text>
			<xsl:for-each select="/lsd:lsd/lsd:enum">
				<xsl:text>specialize_objectize_for_enum( ::</xsl:text>
				<xsl:for-each select="/lsd:lsd/lsd:packages/lsd:p">
					<xsl:value-of select="concat(text(),'::')"/>
				</xsl:for-each>
				<xsl:value-of select="@name"/>
				<xsl:text> );&nl;</xsl:text>
			</xsl:for-each>
			<xsl:for-each select="/lsd:lsd/lsd:class">
				<xsl:variable name="this-class-name" select="@name"/>
				<xsl:for-each select="lsd:enum">
					<xsl:text>specialize_objectize_for_enum( ::</xsl:text>
					<xsl:for-each select="/lsd:lsd/lsd:packages/lsd:p">
						<xsl:value-of select="concat(text(),'::')"/>
					</xsl:for-each>
					<xsl:value-of select="concat($this-class-name,'::')"/>
					<xsl:value-of select="@name"/>
					<xsl:text> );&nl;</xsl:text>
				</xsl:for-each>
			</xsl:for-each>
			<xsl:text>end_package(std);&nl;</xsl:text>
			<xsl:text>end_package(lestes);&nl;&nl;</xsl:text>
		</xsl:if>

		<xsl:call-template name="close-header"/>	<!-- #endif -->

	</xsl:template>	<!-- end of root element template -->


	<!-- generate body of a class declaration -->
	<xsl:template name="class-body">
		<xsl:param name="this-class-name"/>
		<xsl:param name="base-class-name"/>
		<xsl:param name="abstract"/>
		<xsl:text>public:&nl;&tab;</xsl:text>

		<xsl:call-template name="typedefs">
			<xsl:with-param name="indent" select="'&tab;'"/>
		</xsl:call-template>
		<xsl:call-template name="enums">
			<xsl:with-param name="indent" select="'&tab;'"/>
		</xsl:call-template>

		<xsl:apply-templates mode="get-set" select="lsd:field | lsd:collection">
			<xsl:with-param name="this-class-name" select="$this-class-name"/>
		</xsl:apply-templates>

		<xsl:for-each select="lsd:method">
			<!-- for each method generate its declaration -->
			<xsl:if test="lsd:dox/lsd:det">
				<xsl:text>// WARNING: Detailed doxygen description for method&nl;&tab;</xsl:text>
				<xsl:text>// should be near it's implementation, not in XML file.&nl;&nl;&tab;</xsl:text>
			</xsl:if>
			<xsl:call-template name="doxygen">
				<xsl:with-param name="indent" select="'&tab;'" />
			</xsl:call-template>
			<xsl:call-template name="method-declaration"/>
		</xsl:for-each> <!-- end of method declarations -->

		<!-- some inherited abstract methods to be declared -->	
		<xsl:for-each select="lsd:declare-abstract-methods">
			<xsl:apply-templates mode="abstract-methods" select="/lsd:lsd/lsd:class[ @name = $this-class-name ]">
				<xsl:with-param name="prefix" select="@prefix"/>
				<xsl:with-param name="suffix" select="@suffix"/>
				<xsl:with-param name="exact" select="@exact"/>
				<xsl:with-param name="skip-defined" select="@skip-defined"/>
				<xsl:with-param name="started-at-class" select=".."/>
			</xsl:apply-templates>
		</xsl:for-each>

		<!-- Visitors follow -->
		<xsl:apply-templates mode="accept-decls" select=".">
			<xsl:with-param name="abstract" select="@abstract"/>
		</xsl:apply-templates>
		<!-- End of visitors -->

		<!-- two factory methods follow (in public section) -->
		<xsl:if test="(string(@abstract) != 'yes') and (string(@create) != 'none') and (count(lsd:singleton) = 0)">
			<!-- abstract classes do not have factory method (may not be instantiated) -->
			<xsl:text>&nl;&tab;//! First generated factory method for class </xsl:text>
			<xsl:value-of select="concat(@name,'.&nl;&tab;')"/>
			<xsl:text>static ptr&lt; </xsl:text>
			<xsl:value-of select="$this-class-name"/>
			<xsl:text> &gt; create (&nl;&tab;&tab;</xsl:text>
			<xsl:apply-templates select="." mode="ctor-args">
				<xsl:with-param name="with-types" select="'yes'"/>
			</xsl:apply-templates>
			<xsl:text>);&nl;&nl;&tab;</xsl:text>

			<xsl:variable name="is-init">
				<xsl:apply-templates mode="check-init" select="."/>
			</xsl:variable>

			<xsl:if test="$is-init != ''">
				<xsl:text>//! Second generated factory method for class </xsl:text>
				<xsl:value-of select="concat(@name,'.&nl;&tab;')"/>
				<xsl:text>static ptr&lt; </xsl:text>
				<xsl:value-of select="$this-class-name"/>
				<xsl:text> &gt; create (&nl;&tab;&tab;</xsl:text>
				<xsl:apply-templates select="." mode="fact-args">
					<xsl:with-param name="with-types" select="'yes'"/>
				</xsl:apply-templates>
				<xsl:text>);&nl;&nl;&tab;</xsl:text>
			</xsl:if>
		</xsl:if>
		<!-- End of factory methods -->

		<xsl:if test="lsd:singleton">
			<!-- check for bad members -->
			<xsl:for-each select="lsd:field[ string(@specifier)!='static' and count(@init)=0 ]">
				<xsl:message terminate="yes">
					<xsl:value-of select="concat(&quot;In singleton '&quot;,$this-class-name,&quot;': &quot;)"/>
					<xsl:value-of select="concat(&quot;Member '&quot;,@name,&quot;' must be static or initialized.&quot;)"/>
				</xsl:message>
			</xsl:for-each>
			<!-- if ok, then generate instance() and the_instance -->
			<xsl:text>&nl;&tab;//! Generated instance() method for singleton class </xsl:text>
			<xsl:value-of select="concat(@name,'.&nl;&tab;')"/>
			<xsl:text>static ptr&lt; </xsl:text>
			<xsl:value-of select="$this-class-name"/>
			<xsl:text> &gt; instance ();&nl;&nl;&tab;</xsl:text>
		</xsl:if>
		
		<!-- "visit-return" methods -->
		<xsl:text>&nl;</xsl:text>
		<xsl:apply-templates mode="visit-return" select="lsd:visit-return-method" />
		<xsl:text>&nl;&tab;</xsl:text>

		<xsl:text>//! for purposes of dumping&nl;&tab;</xsl:text>
		<xsl:text>virtual ptr&lt;reflection_list&gt; reflection_get() const;&nl;&tab;</xsl:text>
		<xsl:text>//! for purposes of dumping&nl;&tab;</xsl:text>
		<xsl:text>virtual ptr&lt;field_list_list&gt; field_values_get() const;&nl;&tab;</xsl:text>

		<xsl:text>&nl;protected:&nl;&tab;</xsl:text>
		<!-- constructor follows -->
		<xsl:text>//! Generated constructor for class </xsl:text>
		<xsl:value-of select="$this-class-name"/>
		<xsl:text>.&nl;&tab;</xsl:text>
		<xsl:value-of select="concat($this-class-name,' (&nl;&tab;&tab;')"/>
		<xsl:apply-templates select="." mode="ctor-args">
			<xsl:with-param name="with-types" select="'yes'"/>
		</xsl:apply-templates>
		<xsl:text>);&nl;&nl;&tab;</xsl:text>
		<!-- end of constructor -->
		<!-- mark routine (for gc) follows -->
		<xsl:text>//! Marking routine for class </xsl:text>
		<xsl:value-of select="$this-class-name"/>
		<xsl:text>. &nl;&tab;virtual void gc_mark();&nl;</xsl:text>
		<!-- end of mark routine -->

		<xsl:text>&nl;private:&nl;&tab;</xsl:text>
		<!-- member declarations follow -->
		<xsl:apply-templates mode="member-decls" select="lsd:field | lsd:collection"/>

		<xsl:text>static ptr&lt;reflection_list&gt; reflection;&nl;&tab;</xsl:text>
		<xsl:if test="lsd:singleton">
			<xsl:value-of select="concat('static ptr&lt;',$this-class-name,'&gt; the_instance;&nl;&tab;')"/>
		</xsl:if>
		
	</xsl:template>	<!-- end of class body template -->

	<xsl:template name="typedefs">
		<xsl:param name="indent"/>
		<xsl:for-each select="lsd:typedef">
			<xsl:call-template name="doxygen">
				<xsl:with-param name="indent" select="$indent"/>
			</xsl:call-template>
			<xsl:value-of select="concat('typedef ',@type,' ',@name,';&nl;',$indent)"/>
		</xsl:for-each>
		<xsl:if test="lsd:typedef">
			<xsl:value-of select="concat('&nl;',$indent)"/>
		</xsl:if>
	</xsl:template>

	<xsl:template name="enums">
		<xsl:param name="indent"/>
		<xsl:for-each select="lsd:enum">		<!-- list of enum types -->
			<xsl:call-template name="doxygen">
				<xsl:with-param name="indent" select="$indent"/>
			</xsl:call-template>
			<xsl:value-of select="concat('enum ',@name,' {')"/>
			<xsl:for-each select="lsd:e">
				<xsl:value-of select="concat('&nl;',$indent,'&tab;',@n)"/>
				<xsl:if test="string-length(@val)">
					<xsl:value-of select="concat(' = ',@val)"/>
				</xsl:if>
				<xsl:if test="not(position()=last())">
					<xsl:text>,</xsl:text>
				</xsl:if>
			</xsl:for-each>
			<xsl:value-of select="concat('&nl;',$indent,'};&nl;')"/>
		</xsl:for-each>
		<xsl:if test="lsd:enum">
			<xsl:value-of select="concat('&nl;',$indent)"/>
		</xsl:if>
	</xsl:template>

	<xsl:template match="lsd:collection" mode="member-decls">
		<xsl:call-template name="doxygen">
			<xsl:with-param name="indent" select="'&tab;'"/>
		</xsl:call-template>
		<!-- for each collection, generate declaration of its pointer -->
		<xsl:call-template name="specifier"/>
		<xsl:choose>
			<xsl:when test="string(@specifier) != 'static'">
				<xsl:call-template name="col-srp"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="col-ptr"/>
			</xsl:otherwise>
		</xsl:choose>
		<xsl:value-of select="concat('  ',@name,';&nl;&tab;')"/>
	</xsl:template>

	<xsl:template match="lsd:field" mode="member-decls">
		<xsl:call-template name="doxygen">
			<xsl:with-param name="indent" select="'&tab;'"/>
		</xsl:call-template>
		<!-- for each field, generate declaration of its pointer -->
		<xsl:call-template name="specifier"/>
		<xsl:choose>
			<xsl:when test="string(@specifier) != 'static'">
				<xsl:call-template name="val-or-srp">
					<xsl:with-param name="data-type" select="@type"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="val-or-ptr">
					<xsl:with-param name="data-type" select="@type"/>
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
		<xsl:value-of select="concat(' ',@name,';&nl;&tab;')"/>
	</xsl:template>

	<xsl:template match="lsd:field" mode="get-set">
		<xsl:param name="this-class-name"/>
		<!-- for each field generate declaration of its get(), set() methods -->
		<xsl:if test="not(@get = 'none')">
			<xsl:text>//! The method </xsl:text>
			<xsl:value-of select="@name"/>
			<xsl:text>_get returns the value of the field </xsl:text>
			<xsl:value-of select="concat($this-class-name,'::',@name)"/>
			<xsl:text>.&nl;&tab;</xsl:text>
			<xsl:if test=" string(@specifier)!='' ">
				<xsl:value-of select="@specifier"/>
				<xsl:text> </xsl:text>
			</xsl:if>
			<xsl:call-template name="val-or-ptr">
				<xsl:with-param name="data-type" select="@type"/>
			</xsl:call-template>
			<xsl:value-of select="concat(' ',@name,'_get()')"/>
			<xsl:if test="string(@specifier) != 'static'">
				<xsl:text> const</xsl:text>
			</xsl:if>
			<xsl:text>;&nl;&nl;&tab;</xsl:text>
		</xsl:if>
		<xsl:if test="not(@set = 'none')">
			<xsl:text>//! The method </xsl:text>
			<xsl:value-of select="@name"/>
			<xsl:text>_set sets the field </xsl:text>
			<xsl:value-of select="concat($this-class-name,'::',@name)"/>
			<xsl:text> to the given value.&nl;&tab;</xsl:text>
			<xsl:if test=" string(@specifier)!='' ">
				<xsl:value-of select="@specifier"/>
				<xsl:text> </xsl:text>
			</xsl:if>
			<xsl:text>void </xsl:text>
			<xsl:value-of select="@name"/>
			<xsl:text>_set(</xsl:text>
			<xsl:call-template name="val-or-const-ptr-ref">
				<xsl:with-param name="data-type" select="@type"/>
			</xsl:call-template>
			<xsl:text>);&nl;&nl;&tab;</xsl:text>
		</xsl:if>
		<!--xsl:if test="not(@alt = 'none')">
			<xsl:text>//! The method </xsl:text>
			<xsl:value-of select="@name"/>
			<xsl:text>_alt alternates the field </xsl:text>
			<xsl:value-of select="concat($this-class-name,'::',@name)"/>
			<xsl:text> and returns it's new value.&nl;&tab;</xsl:text>
			<xsl:if test=" string(@specifier)!='' ">
				<xsl:value-of select="@specifier"/>
				<xsl:text> </xsl:text>
			</xsl:if>
			<xsl:call-template name="val-or-ptr">
				<xsl:with-param name="data-type" select="@type"/>
			</xsl:call-template>
			<xsl:value-of select="concat(' ',@name)"/>
			<xsl:text>_alt(</xsl:text>
			<xsl:call-template name="val-or-const-ptr-ref">
				<xsl:with-param name="data-type" select="@type"/>
			</xsl:call-template>
			<xsl:text>);&nl;&nl;&tab;</xsl:text>
		</xsl:if-->
	</xsl:template>

	<xsl:template match="lsd:collection" mode="get-set">
		<xsl:param name="this-class-name"/>
		<!-- for each collection generate declaration of its get(), set() methods -->
		<xsl:if test="not(@get = 'none')">
			<xsl:text>//! The method </xsl:text>
			<xsl:value-of select="@name"/>
			<xsl:text>_get returns the value of the field </xsl:text>
			<xsl:value-of select="concat($this-class-name,'::',@name)"/>
			<xsl:text>.&nl;&tab;</xsl:text>
			<xsl:if test=" string(@specifier)!='' ">
				<xsl:value-of select="@specifier"/>
				<xsl:text> </xsl:text>
			</xsl:if>
			<xsl:call-template name="col-ptr"/>
			<xsl:value-of select="concat(' ',@name,'_get()')"/>
			<xsl:if test="string(@specifier) != 'static'">
				<xsl:text> const</xsl:text>
			</xsl:if>
			<xsl:text>;&nl;&nl;&tab;</xsl:text>
		</xsl:if>
		<xsl:if test="not(@set = 'none')">
			<xsl:text>//! The method </xsl:text>
			<xsl:value-of select="@name"/>
			<xsl:text>_set sets the field </xsl:text>
			<xsl:value-of select="concat($this-class-name,'::',@name)"/>
			<xsl:text> to the given value.&nl;&tab;</xsl:text>
			<xsl:if test=" string(@specifier)!='' ">
				<xsl:value-of select="@specifier"/>
				<xsl:text> </xsl:text>
			</xsl:if>
			<xsl:text>void </xsl:text>
			<xsl:value-of select="@name"/>
			<xsl:text>_set(const </xsl:text>
			<xsl:call-template name="col-ptr"/>
			<xsl:text> &amp; );&nl;&nl;&tab;</xsl:text>
		</xsl:if>
		<!--xsl:if test="not(@alt = 'none')">
			<xsl:text>//! The method </xsl:text>
			<xsl:value-of select="@name"/>
			<xsl:text>_alt alternates the field </xsl:text>
			<xsl:value-of select="concat($this-class-name,'::',@name)"/>
			<xsl:text> and returns it's new value.&nl;&tab;</xsl:text>
			<xsl:if test=" string(@specifier)!='' ">
				<xsl:value-of select="@specifier"/>
				<xsl:text> </xsl:text>
			</xsl:if>
			<xsl:call-template name="col-ptr"/>
			<xsl:value-of select="concat(' ',@name,'_alt(')"/>
			<xsl:call-template name="col-ptr"/>
			<xsl:text> &amp; );&nl;&nl;&tab;</xsl:text>
		</xsl:if-->
	</xsl:template>

	<xsl:template mode="accept-decls" match="lsd:class">
		<xsl:param name="abstract"/>
		<xsl:for-each select="lsd:visitor">	<!-- my visitors -->
			<xsl:text>virtual </xsl:text>
			<xsl:call-template name="val-or-ptr">
				<xsl:with-param name="data-type" select="@type"/>
			</xsl:call-template>
			<xsl:value-of select="concat(' accept_',@name,'( ptr&lt; ',@name,' &gt; v )')"/>
			<xsl:if test="$abstract = 'yes'">
				<xsl:text> abstract</xsl:text>
			</xsl:if>
			<xsl:text>;&nl;&tab;</xsl:text>
		</xsl:for-each>
		<xsl:variable name="base-class-name">
			<xsl:call-template name="resolve-base"/>
		</xsl:variable>
		<xsl:choose>
			<xsl:when test="document('',.)/lsd:lsd/lsd:class[@name = $base-class-name]">
				<xsl:apply-templates mode="accept-decls" select="document('',.)/lsd:lsd/lsd:class[@name = $base-class-name]">
					<xsl:with-param name="abstract" select="$abstract"/>
				</xsl:apply-templates>
			</xsl:when>
			<xsl:otherwise>
				<xsl:variable name="doc">
					<xsl:call-template name="class-lookup">
						<xsl:with-param name="class" select="$base-class-name"/>
					</xsl:call-template>
				</xsl:variable>
				<xsl:if test="string-length($doc) != 0">
					<xsl:apply-templates mode="accept-decls" select="document($doc,.)/lsd:lsd/lsd:class[@name = $base-class-name]">
						<xsl:with-param name="abstract" select="$abstract"/>
					</xsl:apply-templates>
				</xsl:if>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template match="lsd:class" mode="abstract-methods">
		<!--
		declare abstract methods matched by prefix/suffix/exact

		always seach base classes for 'method' nodes, this class is only
		searched when search-this-class is not empty
		-->
		<xsl:param name="prefix"/>
		<xsl:param name="suffix"/>
		<xsl:param name="exact"/>
		<xsl:param name="skip-defined"/>
		<xsl:param name="search-this-class"/>
		<xsl:param name="started-at-class"/>
		<xsl:variable name="this-class-name" select="@name"/>
		<xsl:variable name="base">
			<xsl:call-template name="stripped-base"/>
		</xsl:variable>
		<xsl:variable name="root">
			<!-- search for a file containing the base class -->
			<xsl:call-template name="class-lookup">
				<xsl:with-param name="class" select="$base"/>
			</xsl:call-template>
		</xsl:variable>
		<!-- apply recursively to the base class (either here or in external file) -->
		<xsl:apply-templates mode="abstract-methods" select="(/lsd:lsd/lsd:class|document($root,.)/lsd:lsd/lsd:class)[@name = $base]">
			<xsl:with-param name="prefix" select="$prefix"/>
			<xsl:with-param name="suffix" select="$suffix"/>
			<xsl:with-param name="exact" select="$exact"/>
			<xsl:with-param name="skip-defined" select="$skip-defined"/>
			<xsl:with-param name="search-this-class" select="'yes'"/>
			<xsl:with-param name="started-at-class" select="$started-at-class"/>
		</xsl:apply-templates>
		<!-- list my own abstract methods, if told to -->
		<xsl:if test="string-length($search-this-class) > 0">
			<xsl:for-each select="lsd:method[ contains(@qualifier,'abstract') ]">
				<xsl:variable name="matches">
					<xsl:call-template name="match-method-name">
						<xsl:with-param name="name" select="@name" />
						<xsl:with-param name="prefix" select="$prefix" />
						<xsl:with-param name="suffix" select="$suffix" />
						<xsl:with-param name="exact" select="$exact" />
					</xsl:call-template>
				</xsl:variable>
				<xsl:if test="string-length($matches) > 0">
					<xsl:variable name="defined">
						<!--
						when the user does not want to skip defined methods,
						pretend they are not defined (and leave the variable empty)
						-->
						<xsl:if test="string($skip-defined) = 'yes'">
							<xsl:apply-templates mode="find-defined-method" select="$started-at-class">
								<xsl:with-param name="method" select="@name" />
							</xsl:apply-templates>
						</xsl:if>
					</xsl:variable>
					<xsl:if test="string-length($defined) = 0">
						<xsl:call-template name="specifier"/>
						<xsl:call-template name="val-or-ptr">
							<xsl:with-param name="data-type" select="@type"/>
						</xsl:call-template>
						<xsl:value-of select="concat(' ',@name,'(')"/>
						<xsl:for-each select="lsd:param">
							<xsl:call-template name="val-or-ptr">
								<xsl:with-param name="data-type" select="@type"/>
							</xsl:call-template>
							<xsl:value-of select="concat(' ',@name)"/>
							<xsl:if test="not(position()=last())">
								<xsl:text>, </xsl:text>
							</xsl:if>
						</xsl:for-each>
						<xsl:text>)</xsl:text>
						<xsl:value-of select="concat(substring-before(@qualifier,'abstract'),substring-after(@qualifier,'abstract'))"/>
						<xsl:text>;&nl;&nl;&tab;</xsl:text>
					</xsl:if>
				</xsl:if>
			</xsl:for-each>
		</xsl:if>
	</xsl:template>

	<xsl:template match="lsd:class" mode="find-defined-method">
		<!-- output non-empty string when given method is found declared non-abstract
		in given class; method and declare-abstract-methods nodes are considered

		when search-this-class is empty, only base classes are searched

		note that comparison is done purely on the name attribute; this mechanism is not prepared
		for function overloading (when more functions with same name take different arguments)
		-->
		<xsl:param name="method" />
		<xsl:param name="search-this-class" />
		<xsl:variable name="defined-here">
			<xsl:choose>
				<xsl:when test="string-length($search-this-class) = 0">
				</xsl:when>
				<xsl:when test="lsd:method[ @name = $method and not(contains(@qualifier,'abstract')) ]">
					<xsl:text>yes</xsl:text>
				</xsl:when>
				<xsl:otherwise>
					<!--
					note that this template is called only when finding out
					whether to skip a method or not.

					therefore, the test (whether a method has been declared
					by the declare-abstract-methods element) can be reduced
					to matching the name against its prefix/suffix/exact
					attributes.

					if the method name matches, the tag must have
					either declared the method (when it had found it not to be
					declared already, or when skip-defined was disabled), or
					skipped it (when it found it declared).

					either way, we can skip it :-)
					-->
					<xsl:for-each select="lsd:declare-abstract-methods">
						<xsl:call-template name="match-method-name">
							<xsl:with-param name="name" select="$method" />
							<xsl:with-param name="prefix" select="@prefix" />
							<xsl:with-param name="suffix" select="@suffix" />
							<xsl:with-param name="exact" select="@exact" />
						</xsl:call-template>
					</xsl:for-each>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:choose>
			<xsl:when test="string-length($defined-here) > 0">
				<xsl:value-of select="$defined-here" />
			</xsl:when>
			<xsl:otherwise>
				<xsl:variable name="base">
					<xsl:call-template name="stripped-base"/>
				</xsl:variable>
				<xsl:variable name="root">
					<!-- search for a file containing the base class -->
					<xsl:call-template name="class-lookup">
						<xsl:with-param name="class" select="$base"/>
					</xsl:call-template>
				</xsl:variable>
				<!-- apply recursively to the base class (either here or in external file) -->
				<xsl:apply-templates mode="find-defined-method" select="(/lsd:lsd/lsd:class|document($root,.)/lsd:lsd/lsd:class)[@name = $base]">
					<xsl:with-param name="method" select="$method"/>
					<xsl:with-param name="search-this-class" select="'yes'" />
				</xsl:apply-templates>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template name="method-declaration">
		<xsl:call-template name="specifier"/>
		<xsl:call-template name="val-or-ptr">
			<xsl:with-param name="data-type" select="@type"/>
		</xsl:call-template>
		<xsl:value-of select="concat(' ',@name,'(')"/>
		<xsl:for-each select="lsd:param">
			<xsl:call-template name="val-or-ptr">
				<xsl:with-param name="data-type" select="@type"/>
			</xsl:call-template>
			<xsl:value-of select="concat(' ',@name)"/>
			<xsl:if test="not(position()=last())">
				<xsl:text>, </xsl:text>
			</xsl:if>
		</xsl:for-each>
		<xsl:text>)</xsl:text>
		<xsl:call-template name="qualifier"/>
		<xsl:text>;&nl;&nl;&tab;</xsl:text>
	</xsl:template>

	<xsl:template name="match-method-name">
		<!--
		output non-empty string when $name matches $prefix, $suffix, and $exact

		the name must start with prefix (any name matches empty prefix)
		the name must end with suffix (any name matches empyt suffix)
		if exact is specified, the name and exact strings must be equal
		-->
		<xsl:param name="name" />
		<xsl:param name="prefix" />
		<xsl:param name="suffix" />
		<xsl:param name="exact" />
		<xsl:if test="starts-with($name,$prefix) and substring($name,string-length($name) + 1 - string-length($suffix)) = string($suffix) and (string-length($exact) = 0 or $name = $exact)">
			<xsl:text>yes</xsl:text>
		</xsl:if>
	</xsl:template>

	<xsl:template mode="visit-return" match="lsd:visit-return-method">
		<xsl:text>&tab;//! &quot;visit-return&quot; method&nl;&tab;</xsl:text>
		<xsl:choose>
			<xsl:when test="string-length(@get-from) = 0">
				<xsl:text>void</xsl:text>
			</xsl:when>
			<xsl:otherwise>
				<xsl:apply-templates mode="resolve-field-type" select="..">
					<xsl:with-param name="name" select="@get-from" />
					<xsl:with-param name="type" select="'hh'" />
					<!-- only for error reporting: -->
					<xsl:with-param name="err-class" select="../@name" />
					<xsl:with-param name="err-method" select="@name" />
				</xsl:apply-templates>
			</xsl:otherwise>
		</xsl:choose>
		<xsl:variable name="visitor-name">
			<xsl:apply-templates mode="resolve-base-visitor-name" select=".." />
		</xsl:variable>
		<xsl:if test="string-length($visitor-name) = 0">
			<xsl:message terminate="yes">
				<xsl:value-of select="concat('Could not find name of base visitor when processing visit-return-method named &quot;',@name,'&quot; in class &quot;',../@name,'&quot;.')" />
			</xsl:message>
		</xsl:if>
		<xsl:value-of select="concat(' ',@name,'( const ptr&lt; ')" />
		<xsl:apply-templates mode="get-class-with-visitor" select="/lsd:lsd">
			<xsl:with-param name="name" select="$visitor-name" />
		</xsl:apply-templates>
		<xsl:text> &gt; &amp; );&nl;</xsl:text>
	</xsl:template>

</xsl:transform>
